import java.io.DataInputStream;
import java.io.IOException;

import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.L2CAPConnection;
import javax.bluetooth.L2CAPConnectionNotifier;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;

import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.microedition.io.StreamConnectionNotifier;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Display;
import javax.microedition.media.Player;
import javax.microedition.media.PlayerListener;

public class BTServer implements Runnable, PlayerListener {

    private static final UUID PICTURES_SERVER_UUID = new UUID("F0E0D0C0B0A000908070605040302010", false);
    private static final int IMAGES_NAMES_ATTRIBUTE_ID = 0x4321;
    private LocalDevice localDevice;
    private L2CAPConnectionNotifier notifier;
    private ServiceRecord record;
    private boolean isClosed = false, isBTReady = false;
    private static L2CAPConnection conn = null;
    public static int intCount = 0;
    public static DataInputStream inSr = null;
    String url = "btl2cap://localhost:" + PICTURES_SERVER_UUID.toString()+";name=Picture Server;authorize=false";
    private Display display;
    
    public BTServer(Display display){
    	this.display = display;
    	new Thread(this).start();
    }
    
	public static void onDisconnect(){
		if (conn != null) try {conn.close();} catch (IOException e){}; conn = null;
	}
    
    private void informError(String msg){
        Alert al = new Alert("Error", msg, null, AlertType.ERROR);
        al.setTimeout(1000);
        display.setCurrent(al, display.getCurrent());
    }
	
	public void run(){
        try {

            localDevice = LocalDevice.getLocalDevice();
            
            if (!localDevice.setDiscoverable(DiscoveryAgent.GIAC)) {
            }

            notifier = (L2CAPConnectionNotifier) Connector.open(url);
            record = localDevice.getRecord(notifier);

            // remember we've reached this point.
            isBTReady = true;
        } catch (Exception e) {
        	informError("Can't initialize bluetooth: " + e);
        	Console.trace("Can't initialize bluetooth: " + e);
        }
        while (!isClosed) {

            if (conn==null){
            	try {
                    conn = notifier.acceptAndOpen();
                    BTConnection.conn = conn;
                    BTRadio.ref.radio.show();
                    
                } catch (IOException e) {
                    continue;
                } 
            }
            try{
            	Thread.sleep(50);
            }catch (InterruptedException e) {}
            
        	
        }
    }

	public void playerUpdate(Player arg0, String arg1, Object arg2) {
		informError( arg1 + '\n' );		
	}

}
