import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordFilter;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;

public class Settings {

	private static RecordStore rs;
	
	public static final String IMEI_PARAM = "bambucha!";
	public static final String SERVER_IP_PARAM = "liveIsGreat!";
	public static final String USER_TYPE = "whoAreYou?";
	
	public Settings() {
		try {
			rs = RecordStore.openRecordStore( "settings", true );
		} catch ( RecordStoreException e ) {
			//Console.trace( e.toString() );			
		}
	}
	
	public static String getParam( String param ) {
		try {
			int rid = getParamRID( param );
			
			if ( rid == -1 )
				return null;
			
			byte[] byteParam = rs.getRecord( rid );
			ByteArrayInputStream bais = new ByteArrayInputStream( byteParam );
			DataInputStream dis = new DataInputStream( bais );
			
			dis.readUTF();
			return dis.readUTF();			
		} catch ( Exception e ) {
			//Console.trace( "Exception at Settings.getParam() " + e.toString() );
			return null;
		}
	}
	
	public static void setParam ( String param, String value ) {
		try {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			DataOutputStream dos = new DataOutputStream( baos );
			
			dos.writeUTF( param );
			dos.writeUTF( value );
			
			byte[] byteParam = baos.toByteArray();
			
			int rid = getParamRID( param );
			if ( rid == -1 )
				rs.addRecord( byteParam, 0, byteParam.length );
			else rs.setRecord( rid, byteParam, 0, byteParam.length );
			
		} catch ( Exception e ) {
			e.printStackTrace();	
		}
	}
	
	//byte[]
	public static byte[] getParamBytes( String param ) {
		try {
			int rid = getParamRID( param );
			
			if ( rid == -1 )
				return null;
			
			byte[] byteParam = rs.getRecord( rid );
			ByteArrayInputStream bais = new ByteArrayInputStream( byteParam );
			DataInputStream dis = new DataInputStream( bais );
			
			dis.readUTF();
			int length = dis.readInt();
			byte[] result = new byte[length]; 
			dis.read(result,0,length);
			
			return result;			
		} catch ( Exception e ) {
			//Console.trace( "Exception at Settings.getParam() " + e.toString() );
			return null;
		}
	}
	
	//byte[]
	public static void setParamBytes ( String param, byte[] value ) {
		try {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			DataOutputStream dos = new DataOutputStream( baos );
			
			dos.writeUTF( param );
			dos.writeInt(value.length);
			dos.write( value, 0, value.length );
			
			byte[] byteParam = baos.toByteArray();
			
			int rid = getParamRID( param );
			if ( rid == -1 )
				rs.addRecord( byteParam, 0, byteParam.length );
			else rs.setRecord( rid, byteParam, 0, byteParam.length );
			
		} catch ( Exception e ) {
			//Console.trace( "Exception at Settings.setParam() " + e.toString() );	
		}
	}
	
	private static int getParamRID( String paramName ) {
		int ret;
		RecordEnumeration rEnum = null;
		
		try {			
			rEnum = rs.enumerateRecords( new ParamFilter( paramName ), null, false );
			
			if ( rEnum.numRecords() != 1 )
				ret = -1;
			else ret = rEnum.nextRecordId();
			
		} catch ( Exception e ) {
			ret = -1;
		} 
		if ( rEnum != null ) rEnum.destroy();
		
		return ret;
	}
}

class ParamFilter implements RecordFilter {
	
	private String matchParamName;
	
	public ParamFilter( String name ) {
		matchParamName = name;
	}
	
	public boolean matches(byte[] arg0) {
		ByteArrayInputStream bais = new ByteArrayInputStream( arg0 );
		DataInputStream dis = new DataInputStream( bais );
		
		try {
			String paramName = dis.readUTF();
			return paramName.equals( matchParamName );			
		} catch ( IOException e ) {}
		
		return false;
	}
}